# -*- Mode: Python; tab-width: 4 -*-

import string

def emit_dict (o, emit):
    emit ('<dl>')
    for k,v in o:
        emit ('<dl>')
        emit ('<dt>%s<dd>' % k)
        pprint_html (v, emit)
    emit ('</dl>')
    
def emit_list (o, emit):
    emit ('<ul>')
    for x in o:
        emit ('<li>')
        pprint_html (x, emit)
        emit ('</li>')
    emit ('</ul>')

def clean (s):
    s = string.replace (s, '<', '&lt;')
    s = string.replace (s, '>', '&gt;')
    return s

def no_subs (o):
    if filter (lambda x: type(x) in (type(()),type([])), o):
        return 0
    else:
        return 1

def pprint_html (o, emit):
    if type(o) is type([]):
        emit_list (o, emit)
    elif type(o) is type(()):
        if (len(o)==2) and (type(o[0]) is type('')):
            # special-case for our exif dump
            emit ('<b>')
            emit (clean (o[0]))
            emit ('</b> ')
            if no_subs (o[1]):
                emit (clean (repr (o[1])))
            else:
                pprint_html (o[1], emit)
        else:
            emit_list (o, emit)
    elif type(o) is type({}):
        emit_dict (o, emit)
    elif type(o) is type(''):
        emit(clean(o))
    else:
        emit(clean(repr(o)))
